package matsubara.gear;

import java.awt.Color;
import java.awt.Graphics;

/**
 * ^Cg:  Gear base
 * :    ׂĂ̎ԃNX̊b
 * 쌠:   Copyright (c) 2001
 * Ж:
 * @author a
 * @version 1.0
 */

public abstract class GearBase {
  int m_nPosX = 0;
  int m_nPosY = 0;
  double m_rSize = 100;
  double m_rAngle = 0.0;  //  Ԃ̌Xiǂꂾ]Ă邩EWAj
  Color m_color1 = Color.white;
  Color m_color2 = Color.blue;

  public GearBase() {
  }

  public int getPosX() {
    return m_nPosX;
  }
  public void setPosX(int newPosX) {
    m_nPosX = newPosX;
  }
  public int getPosY() {
    return m_nPosY;
  }
  public void setPosY(int newPosY) {
    m_nPosY = newPosY;
  }
  public double getSize() {
    return m_rSize;
  }
  public void setSize(double newSize) {
    m_rSize = newSize;
  }
  public double getAngle() {
    return m_rAngle;
  }
  public void setAngle(double newAngle) {
    m_rAngle = newAngle;
    m_rAngle %= (2 * Math.PI);
    if (m_rAngle < 0)
      m_rAngle += 2 * Math.PI;

  }
  public Color getColor1() {
    return m_color1;
  }
  public void setColor1(Color newColor1) {
    m_color1 = newColor1;
  }
  public Color getColor2() {
    return m_color2;
  }
  public void setColor2(Color newColor2) {
    m_color2 = newColor2;
  }

  public int rotateX(int nSize, double rDefAngle) {
    return (int)(m_nPosX + nSize * Math.cos(m_rAngle + rDefAngle));
  }
  public int rotateY(int nSize, double rDefAngle) {
    return (int)(m_nPosY + nSize * Math.sin(m_rAngle + rDefAngle));
  }
  public int rotateX(double rSize, double rDefAngle) {
    return (int)(m_nPosX + rSize * Math.cos(m_rAngle + rDefAngle));
  }
  public int rotateY(double rSize, double rDefAngle) {
    return (int)(m_nPosY + rSize * Math.sin(m_rAngle + rDefAngle));
  }

  public abstract void draw(Graphics g);
}