package matsubara.carcontroller;

/**
 * <p>^Cg: Car Controller</p>
 * <p>: N}̐EgX~bVȂǂ𐧌䂷</p>
 * <p>쌠: Copyright (c) 2002</p>
 * <p>Ж: </p>
 * @author a
 * @version 1.0.2
 */

public abstract class CarController {
  String m_sShiftPosition;
  boolean m_bParkingBrake;

  double m_rOdoMeter = 0;
  double m_rTripMeter = 0;

  double m_rAcceleration = 0;

  public CarController() {
    m_sShiftPosition = "N";   //  m|WVȂ炽Ă̎ԂɂĂ邾낤iȂႢȂjBhNXŏ㏑B
    m_bParkingBrake = false;
  }

  //  ShiftPosition ̒lƂĎۂɂǂ̂悤Ȓl邩̓NXɈˑ
  public String getShiftPosition() {
    return m_sShiftPosition;
  }
  public void setShiftPosition(String sShiftPosition) {
    m_sShiftPosition = sShiftPosition;
  }
  public boolean isParkingBrake() {
    return m_bParkingBrake;
  }
  public void setParkingBkare(boolean bParkingBrake) {
    m_bParkingBrake = bParkingBrake;
  }

  //  rMilliSec ŕ\鎞ԕV~[g, nAccel, nBrake ́AANZAu[L̓ݍݗ(%)
  public void drive(double rMilliSec, int nAccel, int nBrake) {
    double rLastSpeed = getSpeed();
    driveInternal(rMilliSec, nAccel, nBrake);

    double rSpeed = Math.abs(getSpeed());
    m_rOdoMeter += rSpeed * rMilliSec / (1000 * 60 * 60);
    m_rTripMeter += rSpeed * rMilliSec / (1000 * 60 * 60);
    m_rAcceleration = (getSpeed() - rLastSpeed) * 1000 / 3600 / (rMilliSec / 1000); // m/s2
  }
  protected abstract void driveInternal(double rMilliSec, int nAccel, int nBrake);

  public abstract double getSpeed();
  public abstract double getEngineRpm();

  public int getOdoMeter() {
    return (int)m_rOdoMeter;
  }
  public double getTripMeter() {
    return m_rTripMeter;
  }
  public void resetTripMeter() {
    m_rTripMeter = 0;
  }
  //  Odrive\bhŌĂяoꂽƂ̉x(m/s2)
  public double getAcceleration() {
    return m_rAcceleration;
  }
}