package matsubara.gear;

import java.awt.Color;
import java.awt.Graphics;

/**
 * ^Cg:  Gear
 * :    ʓIȎ
 * 쌠:   Copyright (c) 2001
 * Ж:
 * @author a
 * @version 1.0
 */

public class Gear extends GearBase {

  int m_nGearCount = 50;
  int m_nGearDepth = 4;

  public Gear() {
  }
  public Gear(int nPosX, int nPosY, double rSize, int nGearCount, int nGearDepth) {
    setPosX(nPosX);
    setPosY(nPosY);
    setSize(rSize);
    setGearCount(nGearCount);
    setGearDepth(nGearDepth);
  }


  public int getGearCount() {
    return m_nGearCount;
  }
  public void setGearCount(int newGearCount) {
    m_nGearCount = newGearCount;
  }
  public int getGearDepth() {
    return m_nGearDepth;
  }
  public void setGearDepth(int newGearDepth) {
    m_nGearDepth = newGearDepth;
  }

  public void draw(Graphics g) {
    int[] nxX = new int[3], nxY = new int[3];
    double rGearAngle;  //  ЂƂ̎̊pxiWAj
    double rIdx;
    double rSizeH = m_rSize + (double)m_nGearDepth / 2;  //  MA̎R̍
    double rSizeL = m_rSize - (double)m_nGearDepth / 2;  //  MA̒J̍
    rGearAngle = 2 * Math.PI / m_nGearCount;  //  1̃MÅpx
    //  ~iColor1j
    g.setColor(m_color1);
    //  ̒JP
    nxX[2] = rotateX(rSizeL - 1, 0);
    nxY[2] = rotateY(rSizeL - 1, 0);
    for (rIdx = 0.0; rIdx < Math.PI - 0.000001; rIdx += rGearAngle) {
      //  ̒JP
      nxX[0] = nxX[2];
      nxY[0] = nxY[2];
      //  ̎R
      nxX[1] = rotateX(rSizeH, rIdx + rGearAngle / 2);
      nxY[1] = rotateY(rSizeH, rIdx + rGearAngle / 2);
      //  ̒JQ
      nxX[2] = rotateX(rSizeL - 1, rIdx + rGearAngle);
      nxY[2] = rotateY(rSizeL - 1, rIdx + rGearAngle);
      g.fillPolygon(nxX, nxY, 3);
    }
    g.fillArc(m_nPosX - (int)rSizeL, m_nPosY - (int)rSizeL, (int)(rSizeL * 2), (int)(rSizeL * 2), 180 - (int)(m_rAngle / (2 * Math.PI) * 360), 180);


    //  ~iColor2j
    g.setColor(m_color2);
    if (getGearCount() % 2 == 1) {
      //  ̐̂ƂA̒ŐF邽߂̑Ώ
      nxX[0] = rotateX(rSizeL - 1, rIdx - rGearAngle / 2);
      nxY[0] = rotateY(rSizeL - 1, rIdx - rGearAngle / 2);
      g.fillPolygon(nxX, nxY, 3);
    }
    //  ̒JQ
    nxX[2] = rotateX(rSizeL - 1, rIdx);
    nxY[2] = rotateY(rSizeL - 1, rIdx);
    for (rIdx = rIdx; rIdx < 2 * Math.PI - 0.000001; rIdx += rGearAngle) {
      //  ̒JP
      nxX[0] = nxX[2];
      nxY[0] = nxY[2];
      //  ̎R
      nxX[1] = rotateX(rSizeH, rIdx + rGearAngle / 2);
      nxY[1] = rotateY(rSizeH, rIdx + rGearAngle / 2);
      //  ̒JQ
      nxX[2] = rotateX(rSizeL - 1, rIdx + rGearAngle);
      nxY[2] = rotateY(rSizeL - 1, rIdx + rGearAngle);
      g.fillPolygon(nxX, nxY, 3);
    }
    g.fillArc(m_nPosX - (int)rSizeL, m_nPosY - (int)rSizeL, (int)(rSizeL * 2), (int)(rSizeL * 2), 360 - (int)(m_rAngle / (2 * Math.PI) * 360), 180);

    //  MA̎
    g.setColor(Color.darkGray);
    g.fillArc(m_nPosX - 7, m_nPosY - 7, 14, 14, 0, 360);
    g.setColor(Color.black);
    g.drawArc(m_nPosX - 7, m_nPosY - 7, 14, 14, 0, 360);
  }
}