package matsubara.thssimulator;

import java.awt.*;
import java.awt.event.*;
import java.applet.*;
import javax.swing.*;
import javax.swing.event.*;
import javax.swing.border.*;

import java.awt.image.*;
import java.util.Timer;
import java.util.TimerTask;
import java.text.*;

import matsubara.gear.*;
import matsubara.graphics.*;
import matsubara.carcontroller.*;

/**
 * ^Cg:  sgrV~[^
 * :    vEX̃nCubhVXeisgrĵ̃V~[V
 * 쌠:   Copyright (c) 2001
 * Ж:
 * @author a
 * @version 1.0
 */


class ThsDrawTimer extends TimerTask {
  ThsApplet m_applet;
  Graphics m_graphics;
  ThsDrawTimer(ThsApplet applet) {
    m_applet = applet;
    m_graphics = m_applet.getGraphics();
  }
  public void run() {
    m_applet.moveThs(m_applet.getInterval());
    m_applet.drawThsGear(m_applet.getGraphics());
  }
}


public class ThsApplet extends JApplet {
//  mc_sApplicationName + " " + mc_sVersion + " " + mc_sCopyright
  public final String mc_sApplicationName = "vEXEhCrOEV~[^";
  public final String mc_sVersion = "version 1.1.1";
  public final String mc_sCopyright = "copyright(c) 2002 matsubara masakazu";

  int m_nInterval = 67;
  ThsController m_thsController = new ThsController(80, 80, 60);

  BufferedImage m_img = new BufferedImage(160, 160, BufferedImage.TYPE_INT_RGB);  //  vl^MA`pobt@

  Image[] m_imgPrius = new Image[2];  //  s̃vEX̉摜QiQɕ\đĂ銴oj
  int m_nImgPriusNo = 0;               //  \̃vEX̔ԍ
  Image m_imgMotor;           //  [^[\ACRiIW̓dj
  Image m_imgKaisei;          //  񐶔d\ACRi΂̓dj
  Image m_imgGasoline;        //  GW̓\ACRiK\X^hj
  Image m_imgMeter;           //  [^[
  Image m_imgEnergyMonitor;   //  GlM[j^̐}
  Image m_imgEgMonitor;       //  GlM[j^̐}2

  //  GlM[j^̈ʒu
  final int m_nEmOffsetX = 447;
  final int m_nEmOffsetY =   0;
  //  GlM[j^ŃGlM[̗\AQĂ啶̈Ӗ͈ȉ̂Ƃ
  //    B : obe[, I : Co[^[,   M : [^[, F : t@CiMA
  //    G : d@,     P : vl^MA, E : GW, T : ^C
  ProgressLine m_lineBI = new ProgressLine(m_nEmOffsetX + 121, m_nEmOffsetY +  38, m_nEmOffsetX + 112, m_nEmOffsetY +  64, Color.red, 6);
  ProgressLine m_lineIM = new ProgressLine(m_nEmOffsetX + 112, m_nEmOffsetY +  64, m_nEmOffsetX + 102, m_nEmOffsetY +  94, Color.red, 6);
  ProgressLine m_lineMF = new ProgressLine(m_nEmOffsetX + 102, m_nEmOffsetY +  94, m_nEmOffsetX +  83, m_nEmOffsetY +  88, Color.red, 6);
  ProgressLine m_lineIG = new ProgressLine(m_nEmOffsetX + 112, m_nEmOffsetY +  64, m_nEmOffsetX +  85, m_nEmOffsetY +  57, Color.red, 6);
  ProgressLine m_lineGP = new ProgressLine(m_nEmOffsetX +  85, m_nEmOffsetY +  57, m_nEmOffsetX +  72, m_nEmOffsetY +  84, Color.red, 6);
  ProgressLine m_lineEP = new ProgressLine(m_nEmOffsetX +  50, m_nEmOffsetY +  77, m_nEmOffsetX +  72, m_nEmOffsetY +  84, Color.red, 6);
  ProgressLine m_linePF = new ProgressLine(m_nEmOffsetX +  72, m_nEmOffsetY +  84, m_nEmOffsetX +  83, m_nEmOffsetY +  88, Color.red, 6);
  ProgressLine m_lineFT = new ProgressLine(m_nEmOffsetX +  83, m_nEmOffsetY +  88, m_nEmOffsetX +  70, m_nEmOffsetY + 116, Color.red, 6);

  //  H`p̃obt@ȀɃvEX⃁[^[AGlM[j^Ȃǂ\B
  BufferedImage m_imgRoad = new BufferedImage(600, 180, BufferedImage.TYPE_INT_RGB);
  double m_rRoadPosition = 0; //  H̔`悷邽߂̃CfbNXAvEXiނƑB

  //  Avbgŉiɕ\郁bZ[W
  String m_sMessage1 = "";
  String m_sMessage2 = "";

  Timer m_timer;

  boolean isStandalone = false;
  JSlider sliSunGear = new JSlider();
  JLabel lbPlaCarrierSpeed = new JLabel();
  JLabel lbRingGearSpeed = new JLabel();
  JSlider sliRingGear = new JSlider();
  JSlider sliPlaCarrier = new JSlider();
  JLabel lbSunGearSpeed = new JLabel();
  JLabel jLabel3 = new JLabel();
  JLabel jLabel2 = new JLabel();
  JLabel jLabel1 = new JLabel();
  JPanel jPanel1 = new JPanel();
  Border border1;
  JSlider sliAccel = new JSlider();
  JSlider sliBrake = new JSlider();
  JLabel jLabel4 = new JLabel();
  JLabel jLabel5 = new JLabel();
  JCheckBox ckDriveMode = new JCheckBox();
  JPanel jPanel2 = new JPanel();
  TitledBorder titledBorder1;
  JLabel jLabel6 = new JLabel();
  JComboBox cmbRange = new JComboBox();
  /**l̎擾*/
  public String getParameter(String key, String def) {
    return isStandalone ? System.getProperty(key, def) :
      (getParameter(key) != null ? getParameter(key) : def);
  }

  /**Avbg̍\z*/
  public ThsApplet() {
  }
  /**Avbg̏*/
  public void init() {
    try {
      jbInit();
    }
    catch(Exception e) {
      e.printStackTrace();
    }
  }
  /**R|[lg̏*/
  private void jbInit() throws Exception {
    border1 = new EtchedBorder(EtchedBorder.RAISED,Color.white,new Color(142, 142, 142));
    titledBorder1 = new TitledBorder("");
    jLabel1.setBackground(Color.black);
    jLabel1.setForeground(new Color(0, 186, 0));
    jLabel1.setBounds(new Rectangle(214, 0, 65, 24));
    jLabel1.setText("[^[");
    jLabel2.setBackground(Color.black);
    jLabel2.setForeground(Color.red);
    jLabel2.setBounds(new Rectangle(269, 0, 65, 24));
    jLabel2.setText("GW");
    jLabel3.setBackground(Color.black);
    jLabel3.setForeground(Color.blue);
    jLabel3.setBounds(new Rectangle(420, 0, 65, 24));
    jLabel3.setText("d@");
    lbSunGearSpeed.setFont(new java.awt.Font("Dialog", 1, 11));
    lbSunGearSpeed.setForeground(Color.blue);
    lbSunGearSpeed.setHorizontalAlignment(SwingConstants.CENTER);
    lbSunGearSpeed.setBounds(new Rectangle(415, 21, 65, 17));
    lbSunGearSpeed.setText("0 rpm");
    sliPlaCarrier.setMaximum(4000);
    sliPlaCarrier.addMouseListener(new java.awt.event.MouseAdapter() {
      public void mouseReleased(MouseEvent e) {
        sliPlaCarrier_mouseReleased(e);
      }
    });
    sliPlaCarrier.addKeyListener(new java.awt.event.KeyAdapter() {
      public void keyReleased(KeyEvent e) {
        sliPlaCarrier_keyReleased(e);
      }
    });
    sliPlaCarrier.setBounds(new Rectangle(269, 70, 60, 80));
    sliPlaCarrier.addMouseMotionListener(new java.awt.event.MouseMotionAdapter() {
      public void mouseMoved(MouseEvent e) {
        sliPlaCarrier_mouseMoved(e);
      }
    });
    sliPlaCarrier.setBackground(Color.white);
    sliPlaCarrier.setFont(new java.awt.Font("Dialog", 0, 8));
    sliPlaCarrier.addChangeListener(new javax.swing.event.ChangeListener() {
      public void stateChanged(ChangeEvent e) {
        sliPlaCarrier_stateChanged(e);
      }
    });
    sliPlaCarrier.setValue(0);
    sliPlaCarrier.setPaintLabels(true);
    sliPlaCarrier.setOrientation(JSlider.VERTICAL);
    sliPlaCarrier.setMajorTickSpacing(1000);
    sliPlaCarrier.setMinorTickSpacing(5000);
    sliRingGear.setMinorTickSpacing(500);
    sliRingGear.setMajorTickSpacing(1000);
    sliRingGear.setOrientation(JSlider.VERTICAL);
    sliRingGear.setPaintLabels(true);
    sliRingGear.setMinimum(-2000);
    sliRingGear.setValue(0);
    sliRingGear.setMaximum(5500);
    sliRingGear.setBounds(new Rectangle(214, 46, 54, 134));
    sliRingGear.addMouseMotionListener(new java.awt.event.MouseMotionAdapter() {
      public void mouseMoved(MouseEvent e) {
        sliRingGear_mouseMoved(e);
      }
    });
    sliRingGear.addMouseListener(new java.awt.event.MouseAdapter() {
      public void mouseReleased(MouseEvent e) {
        sliRingGear_mouseReleased(e);
      }
    });
    sliRingGear.setBackground(Color.white);
    sliRingGear.setFont(new java.awt.Font("Dialog", 0, 8));
    sliRingGear.addChangeListener(new javax.swing.event.ChangeListener() {
      public void stateChanged(ChangeEvent e) {
        sliRingGear_stateChanged(e);
      }
    });
    lbRingGearSpeed.setFont(new java.awt.Font("Dialog", 1, 11));
    lbRingGearSpeed.setForeground(new Color(0, 186, 0));
    lbRingGearSpeed.setHorizontalAlignment(SwingConstants.CENTER);
    lbRingGearSpeed.setBounds(new Rectangle(214, 21, 65, 17));
    lbRingGearSpeed.setText("0 rpm");
    lbPlaCarrierSpeed.setFont(new java.awt.Font("Dialog", 1, 11));
    lbPlaCarrierSpeed.setForeground(Color.red);
    lbPlaCarrierSpeed.setHorizontalAlignment(SwingConstants.CENTER);
    lbPlaCarrierSpeed.setBounds(new Rectangle(269, 21, 65, 17));
    lbPlaCarrierSpeed.setText("0 rpm");
    sliSunGear.setMaximum(6000);
    sliSunGear.setEnabled(false);
    sliSunGear.setBounds(new Rectangle(420, 36, 54, 164));
    sliSunGear.addMouseMotionListener(new java.awt.event.MouseMotionAdapter() {
      public void mouseMoved(MouseEvent e) {
        sliSunGear_mouseMoved(e);
      }
    });
    sliSunGear.setBackground(Color.white);
    sliSunGear.setFont(new java.awt.Font("Dialog", 0, 8));
    sliSunGear.setPaintLabels(true);
    sliSunGear.setMinimum(-3000);
    sliSunGear.setValue(0);
    sliSunGear.setOrientation(JSlider.VERTICAL);
    sliSunGear.setMajorTickSpacing(1000);
    this.setSize(new Dimension(600, 370));
    this.getContentPane().setLayout(null);
    jPanel1.setBackground(Color.white);
    jPanel1.setBounds(new Rectangle(-11, 3, 617, 293));
    jPanel1.addMouseMotionListener(new java.awt.event.MouseMotionAdapter() {
      public void mouseMoved(MouseEvent e) {
        jPanel1_mouseMoved(e);
      }
    });
    jPanel1.setLayout(null);
    sliAccel.setOrientation(JSlider.VERTICAL);
    sliAccel.setValue(0);
    sliAccel.setBackground(SystemColor.control);
    sliAccel.setBounds(new Rectangle(77, 65, 26, 77));
    sliAccel.addChangeListener(new javax.swing.event.ChangeListener() {
      public void stateChanged(ChangeEvent e) {
        sliAccel_stateChanged(e);
      }
    });
    sliAccel.addKeyListener(new java.awt.event.KeyAdapter() {
      public void keyReleased(KeyEvent e) {
        sliAccel_keyReleased(e);
      }
    });
    sliAccel.addMouseListener(new java.awt.event.MouseAdapter() {
      public void mouseReleased(MouseEvent e) {
        sliAccel_mouseReleased(e);
      }
    });
    sliBrake.setBounds(new Rectangle(28, 65, 30, 77));
    sliBrake.addChangeListener(new javax.swing.event.ChangeListener() {
      public void stateChanged(ChangeEvent e) {
        sliBrake_stateChanged(e);
      }
    });
    sliBrake.addKeyListener(new java.awt.event.KeyAdapter() {
      public void keyReleased(KeyEvent e) {
        sliBrake_keyReleased(e);
      }
    });
    sliBrake.addMouseListener(new java.awt.event.MouseAdapter() {
      public void mouseReleased(MouseEvent e) {
        sliBrake_mouseReleased(e);
      }
    });
    sliBrake.setOrientation(JSlider.VERTICAL);
    sliBrake.setValue(0);
    sliBrake.setBackground(SystemColor.control);
    jLabel4.setHorizontalAlignment(SwingConstants.CENTER);
    jLabel4.setText("ANZ");
    jLabel4.setBounds(new Rectangle(56, 142, 60, 17));
    jLabel5.setHorizontalAlignment(SwingConstants.CENTER);
    jLabel5.setText("u[L");
    jLabel5.setBounds(new Rectangle(-2, 142, 58, 17));
    ckDriveMode.setText("^]");
    ckDriveMode.setToolTipText("");
    ckDriveMode.setBackground(SystemColor.control);
    ckDriveMode.setBounds(new Rectangle(24, 4, 75, 25));
    ckDriveMode.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        ckDriveMode_actionPerformed(e);
      }
    });
    jPanel2.setBackground(SystemColor.control);
    jPanel2.setBorder(BorderFactory.createEtchedBorder());
    jPanel2.setBounds(new Rectangle(479, 26, 115, 166));
    jPanel2.addMouseMotionListener(new java.awt.event.MouseMotionAdapter() {
      public void mouseMoved(MouseEvent e) {
        jPanel2_mouseMoved(e);
      }
    });
    jPanel2.setLayout(null);
    jLabel6.setFont(new java.awt.Font("Dialog", 0, 12));
    jLabel6.setForeground(new Color(255, 128, 0));
    jLabel6.setText("͕@\(V)");
    jLabel6.setBounds(new Rectangle(35, 4, 143, 17));
    cmbRange.setBackground(SystemColor.control);
    cmbRange.setBounds(new Rectangle(14, 36, 87, 26));
    cmbRange.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        cmbRange_actionPerformed(e);
      }
    });
    cmbRange.addItemListener(new java.awt.event.ItemListener() {
      public void itemStateChanged(ItemEvent e) {
        cmbRange_itemStateChanged(e);
      }
    });
    this.getContentPane().add(jPanel1, null);
    jPanel1.add(sliSunGear, null);
    jPanel1.add(jLabel3, null);
    jPanel1.add(sliRingGear, null);
    jPanel1.add(jLabel1, null);
    jPanel1.add(lbRingGearSpeed, null);
    jPanel1.add(jLabel2, null);
    jPanel1.add(lbPlaCarrierSpeed, null);
    jPanel2.add(ckDriveMode, null);
    jPanel2.add(jLabel5, null);
    jPanel2.add(jLabel4, null);
    jPanel2.add(sliBrake, null);
    jPanel2.add(sliAccel, null);
    jPanel2.add(cmbRange, null);
    jPanel1.add(sliPlaCarrier, null);
    jPanel1.add(jLabel6, null);
    jPanel1.add(lbSunGearSpeed, null);
    jPanel1.add(jPanel2, null);
  }
  /**Avbg̊Jn*/
  public void start() {
    System.out.println(mc_sApplicationName + " " + mc_sVersion + " " + mc_sCopyright);
    m_imgPrius[0] = loadImage("/matsubara/thssimulator/image/prius1.gif");
    m_imgPrius[1] = loadImage("/matsubara/thssimulator/image/prius2.gif");
    m_imgMotor =    loadImage("/matsubara/thssimulator/image/motor.gif");
    m_imgKaisei =   loadImage("/matsubara/thssimulator/image/kaisei.gif");
    m_imgGasoline = loadImage("/matsubara/thssimulator/image/gasoline.gif");
    m_imgMeter =    loadImage("/matsubara/thssimulator/image/meter.gif");
    m_imgEnergyMonitor = loadImage("/matsubara/thssimulator/image/EnergyMonitor.gif");

    cmbRange.addItem("P Range");
    cmbRange.addItem("R Range");
    cmbRange.addItem("N Range");
    cmbRange.addItem("D Range");
    cmbRange.addItem("B Range");
    cmbRange.setSelectedIndex(0);
    m_thsController.setShiftPosition("P");

    jPanel1.setBounds(getBounds());
    m_timer = new Timer();
    ThsDrawTimer tt = new ThsDrawTimer(this);
    m_timer.schedule(tt, m_nInterval, m_nInterval);
  }
  /**Avbg̒~*/
  public void stop() {
    m_timer.cancel();
    try {
      Thread.sleep(100);  //  `nXbh̒~҂
    }
    catch (Exception e) {
    }
  }
  /**Avbg̔j*/
  public void destroy() {
  }
  /**Avbg̏擾*/
  public String getAppletInfo() {
    return mc_sApplicationName + " " + mc_sVersion + " " + mc_sCopyright;
  }
  /**̎擾*/
  public String[][] getParameterInfo() {
    return null;
  }
  /**Main \bh*/
  public static void main(String[] args) {
    ThsApplet applet = new ThsApplet();
    applet.isStandalone = true;
    JFrame frame = new JFrame();
    //EXIT_ON_CLOSE == 3
    frame.setDefaultCloseOperation(3);
    frame.setTitle(applet.mc_sApplicationName);
    frame.getContentPane().add(applet, BorderLayout.CENTER);
    applet.init();
    applet.start();
    frame.setSize(610, 400);
    Dimension d = Toolkit.getDefaultToolkit().getScreenSize();
    frame.setLocation((d.width - frame.getSize().width) / 2, (d.height - frame.getSize().height) / 2);
    frame.setVisible(true);
  }

  //NtB[̐ݒ
  static {
    try {
      //UIManager.setLookAndFeel(UIManager.getSystemLookAndFeelClassName());
      //UIManager.setLookAndFeel(UIManager.getCrossPlatformLookAndFeelClassName());
    }
    catch(Exception e) {
    }
  }

  Image loadImage(final String sImage) {
    Class myClass = this.getClass();
    Image img;
    try {
      img = createImage((ImageProducer)myClass.getResource(sImage).getContent());
    }
    catch (Exception e) {
      System.out.println("image file load error : " + e.getMessage());
      img = new BufferedImage(100, 20, BufferedImage.TYPE_INT_RGB);  //  t@C̓ǂݍݎsɔ
      Graphics g = img.getGraphics();
      g.setColor(Color.white);
      g.fillRect(0, 0, 100, 20);
      g.setColor(Color.red);
      g.drawString("image load error.", 5, 15);
      return img;
    }
    try {
      MediaTracker mt = new MediaTracker(this);
      mt.addImage(img, 0);
      mt.checkAll(true);
      mt.waitForAll(1000);
    }
    catch (Exception e) {
      e.printStackTrace();
    }
    return img;
  }

  //  `Ԋu(~b)
  public int getInterval() {
    return m_nInterval;
  }

  public void paint(Graphics g) {
    super.paint(g);
    try {
      drawThsGear(g);
    }
    catch (Exception e) {
    }
  }

  /** ݂̃vEX̑x */
  public double getSpeed() {
    return m_thsController.getSpeed();
  }

  /** MA₳܂܂ȃIuWFNg̕` */
  public void drawThsGear(Graphics g) {
    PlanetaryGear planetaryGear = m_thsController.getPlanetaryGear();
    double rSpeed = getSpeed();
    //  vl^[MA̐Fݒ
    if (m_thsController.isGasoline()) {
      planetaryGear.getPlanetaryCarrier().setColor1(Color.white);
      planetaryGear.getPlanetaryCarrier().setColor2(Color.red);
    }
    else {
      planetaryGear.getPlanetaryCarrier().setColor1(new Color(224, 224, 224));
      planetaryGear.getPlanetaryCarrier().setColor2(new Color(224,   0,   0));
    }
    if (planetaryGear.getSunGearSpeed() > 0) {
      planetaryGear.getSunGear().setColor1(Color.white);
      planetaryGear.getSunGear().setColor2(Color.blue);
    }
    else {
      planetaryGear.getSunGear().setColor1(new Color(224, 224, 224));
      planetaryGear.getSunGear().setColor2(new Color(  0,   0, 210));
    }

    //  vl^[MA`
    Graphics gi = m_img.getGraphics();
    gi.setColor(Color.white);
    gi.fillRect(0, 0, m_img.getWidth(), m_img.getHeight());
    planetaryGear.draw(gi);

    //  H
    gi = m_imgRoad.getGraphics();
    gi.setColor(new Color(160, 160, 160));
    gi.fillRect(0, 0, 445, 100);
    gi.setColor(Color.white);
    gi.fillRect(445, 0, 600 - 445, 100);
    gi.setColor(Color.white);
    gi.fillRect(0, 100, 600, 120);
    for (int nIdx = 0 - 65 - (int)m_rRoadPosition; nIdx < m_imgRoad.getWidth() + 100 + (int)m_rRoadPosition; nIdx += 100)
      gi.fillRect(nIdx, 48, 65, 4);

    //  vEX
    gi.drawImage(m_imgPrius[m_nImgPriusNo], 60 + (int)(getSpeed() / 4), 1, null);

    //  [^[
    gi.drawImage(m_imgMeter, 200, 55, null);
    int nRange;
    if (ckDriveMode.isSelected())
      nRange = cmbRange.getSelectedIndex();
    else {
      if (rSpeed > 0)
        nRange = 3; //  D Range
      else if (rSpeed < 0)
        nRange = 1; //  R Range
      else
        nRange = 0; //  P Range
    }
    if (nRange == 1)
      gi.setColor(new Color(255, 100, 0));
    else
      gi.setColor(new Color(64, 255, 255));
    gi.drawRoundRect(200 + 46 + 13 * nRange, 55 + 11, 10, 12, 2, 2);
    String sSpeed = String.valueOf((int)Math.abs(rSpeed));
    //DialogInputAMonospacedASerifASansSerif
    gi.setFont(new Font("Monospaced", 0, 26));
    gi.setColor(new Color(64, 255, 255));
    gi.drawString(sSpeed, 353 - gi.getFontMetrics().stringWidth(sSpeed), 90);

    java.text.DecimalFormat format = new java.text.DecimalFormat("0.0");
    StringBuffer sTrip = format.format(m_thsController.getTripMeter(), new StringBuffer(10), new FieldPosition(4));
    //DialogInputAMonospacedASerifASansSerif
    gi.setFont(new Font("Dialog", 0, 9));
    gi.setColor(new Color(64, 255, 255));
    sTrip.append("km");
    int nWidth = gi.getFontMetrics().stringWidth(sTrip.toString());
    gi.drawString(sTrip.toString(), 310 - nWidth, 90);

    int nNenryo = (int)(m_thsController.getTripMeter() / 100);
    if (nNenryo != 0) {
      if (nNenryo > 10)
        nNenryo = 10;
      gi.setColor(Color.black);
      gi.fillRect(200 + 28, 55 + 6, 7, nNenryo * 3);
      if (m_thsController.getTripMeter() > 880) {
        gi.setColor(new Color(255, 100, 0));
        gi.fillRect(200 + 35, 55 + 33, 4, 3);
      }
    }

    //  GlM[j^
    gi.drawImage(m_imgEnergyMonitor, m_nEmOffsetX, m_nEmOffsetY, null);

    if (ckDriveMode.isSelected()) {
      //  CWP[^[
      if (m_thsController.isMotor())
        gi.drawImage(m_imgMotor, 500 - 450, 55, null);
      if (m_thsController.isKaisei())
        gi.drawImage(m_imgKaisei, 500 - 450, 55, null);
      if (m_thsController.isGasoline())
        gi.drawImage(m_imgGasoline, 540 - 450, 55, null);

      //  GlM[j^
      m_lineBI.setReverse(false);
      m_lineIM.setReverse(false);
      m_lineMF.setReverse(false);
      m_lineIG.setReverse(false);
      m_lineGP.setReverse(false);
      m_lineEP.setReverse(false);
      m_linePF.setReverse(false);
      m_lineFT.setReverse(false);
      m_lineBI.setColor(Color.red);
      m_lineIM.setColor(Color.red);
      m_lineMF.setColor(Color.red);
      m_lineFT.setColor(Color.red);

      double rEnginRpm = m_thsController.getEngineRpm();
      if (rEnginRpm > 0 && rEnginRpm < 1000 && m_thsController.getAcceleration() != 0) {
        gi.setFont(new Font("Dialog", Font.BOLD, 11));
        String sEngineMsg;
        if (m_thsController.getAcceleration() >= 0)
          sEngineMsg = "start";
        else
          sEngineMsg = "stop";
        FontMetrics fm = gi.getFontMetrics();

        gi.setColor(new Color(0xAA, 0x44, 0));
        gi.fillRect(m_nEmOffsetX + 28, m_nEmOffsetY + 73, fm.stringWidth(sEngineMsg) + 4, fm.getHeight());
        gi.setColor(new Color(0xFF, 0x66, 0));
        gi.drawRect(m_nEmOffsetX + 28, m_nEmOffsetY + 73, fm.stringWidth(sEngineMsg) + 4, fm.getHeight());
        gi.drawString(sEngineMsg, m_nEmOffsetX + 30, m_nEmOffsetY + 73 + fm.getAscent());
      }


      switch (m_thsController.getThsMode()) {
      case ThsController.thsStop:
        m_sMessage1 = "GlM[̗͂܂B";
        m_sMessage2 = "";
        break;
      case ThsController.thsStart:
        m_lineBI.draw(gi);
        m_lineIM.draw(gi);
        m_lineMF.draw(gi);
        m_lineFT.draw(gi);
//        m_sMessage1 = "[^[̗͂őĂ܂B";
        m_sMessage1 = "[^[̗͂őĂ܂BGW͒~Ad@͋]܂B";
        m_sMessage2 = "⓹iŃobNȂ悤ɃN[vۂōČ܂B";
        break;
      case ThsController.thsNormal:
        m_lineGP.setReverse(true);
        m_lineIG.setReverse(true);
        m_lineBI.setReverse(true);
        m_lineEP.draw(gi);
        m_linePF.draw(gi);
        m_lineFT.draw(gi);
        m_lineGP.draw(gi);
        m_lineIG.draw(gi);
        m_lineBI.draw(gi);
        m_sMessage1 = "GW̉]͓͕@\łQ̏o͂ɕ܂B";
        m_sMessage2 = "Е̏o͂̓^C𒼐ډ񂵂Е͔d@񂵂܂B";
        break;
      case ThsController.thsNormalOD:
        m_lineIM.setReverse(true);
        m_lineMF.setReverse(true);
        m_lineBI.setReverse(true);
        m_lineBI.setColor(Color.green);
        m_lineEP.draw(gi);
        m_linePF.draw(gi);
        m_lineFT.draw(gi);
        m_lineGP.draw(gi);
        m_lineIG.draw(gi);
        m_lineBI.draw(gi);
        m_lineIM.draw(gi);
        m_lineMF.draw(gi);
        m_sMessage1 = "d@[^[ƂĎgGW̉]ɃvXă^C񂵂܂B";
        m_sMessage2 = "[^[͋tɔdsA]d͂obe[ɏ[d܂B";
        break;
      case ThsController.thsFullAccel:
        m_lineGP.setReverse(true);
        m_lineIG.setReverse(true);
        m_lineBI.draw(gi);
        m_lineIM.draw(gi);
        m_lineMF.draw(gi);
        m_lineIG.draw(gi);
        m_lineGP.draw(gi);
        m_lineEP.draw(gi);
        m_linePF.draw(gi);
        m_lineFT.draw(gi);
        m_sMessage1 = "GW{[^[Ńts܂B";
        m_sMessage2 = "GW]̈ꕔ͔d@ɂēd͂ɕϊꃂ[^[񂵂܂B";
        break;
      case ThsController.thsKaiseiAndEngine:
        m_lineIG.setReverse(true);
        m_lineGP.setReverse(true);
        m_lineEP.setReverse(true);
        m_linePF.setReverse(true);
        m_lineIG.draw(gi);
        m_lineGP.draw(gi);
        m_lineEP.draw(gi);
        m_linePF.draw(gi);
        m_sMessage1 = "N}̉^GlM[[^[gēd͂ɕϊČ܂B";
        m_sMessage2 = "GW͉^GlM[̈ꕔŉ葱܂B";
      case ThsController.thsKaisei:
        m_lineBI.setReverse(true);
        m_lineIM.setReverse(true);
        m_lineMF.setReverse(true);
        m_lineFT.setReverse(true);
        m_lineBI.setColor(Color.green);
        m_lineIM.setColor(Color.green);
        m_lineMF.setColor(Color.green);
        m_lineFT.setColor(Color.green);
        m_lineBI.draw(gi);
        m_lineIM.draw(gi);
        m_lineMF.draw(gi);
        m_lineFT.draw(gi);
        if (m_thsController.getThsMode() == ThsController.thsKaisei) {
          m_sMessage1 = "N}̉^GlM[[^[gēd͂ɕϊČ܂B";
          m_sMessage2 = "GW͒~Ad@͋]܂B";
        }
        break;
      }

    }
    gi.setFont(new Font("Dialog", 0, 10));
    gi.setColor(Color.black);
    gi.drawString(m_sMessage1, 5, 115);
    gi.drawString(m_sMessage2, 5, 135);

    // ۂ̕`
    g.drawImage(m_img, 20, 20, null);
    g.drawImage(m_imgRoad, 0, 215, null);
  }

  /** eIuWFNg̏Ԃɉē */
  synchronized void moveThs(double rMilliSec) {
    PlanetaryGear planetaryGear = m_thsController.getPlanetaryGear();
    //  
    double rSpeed = getSpeed();
    if (ckDriveMode.isSelected()) {
      m_thsController.drive(rMilliSec, sliAccel.getValue(), sliBrake.getValue());
      sliRingGear.setValue((int)planetaryGear.getRingGearSpeed());
      sliPlaCarrier.setValue((int)planetaryGear.getPlaCarrierSpeed());
    }
    else
      planetaryGear.move(rMilliSec / 100);
    m_rRoadPosition += rSpeed / 4;
    m_rRoadPosition %= 100;
    if ((int)rSpeed != 0) {
      //  vEX킸łĂƂ͉摜؂ւ
      m_nImgPriusNo++;
      m_nImgPriusNo %= 2;
    }

    if (ckDriveMode.isSelected()) {
      //  GlM[j^̐𓮂
      m_lineBI.movePosition(7);
      m_lineIM.movePosition(7);
      m_lineMF.movePosition(7);
      m_lineIG.movePosition(7);
      m_lineGP.movePosition(7);
      m_lineEP.movePosition(7);
      m_linePF.movePosition(7);
      m_lineFT.movePosition(7);
    }
  }

  void viewGearsSpeed() {
    PlanetaryGear planetaryGear = m_thsController.getPlanetaryGear();
    int nRingGearSpeed = (int)planetaryGear.getRingGearSpeed();
    int nPlanetaryCarrierSpeed = (int)planetaryGear.getPlaCarrierSpeed();
    int nSunGearSpeed = (int)planetaryGear.getSunGearSpeed();

    nRingGearSpeed -= nRingGearSpeed % 50;
    if (nPlanetaryCarrierSpeed >= 1000)
      nPlanetaryCarrierSpeed -= nPlanetaryCarrierSpeed % 50;
    else
      nPlanetaryCarrierSpeed -= nPlanetaryCarrierSpeed % 10;
    nSunGearSpeed -= nSunGearSpeed % 10;

    lbRingGearSpeed.setText(String.valueOf(nRingGearSpeed) + " rpm");
    lbPlaCarrierSpeed.setText(String.valueOf(nPlanetaryCarrierSpeed) + " rpm");
    lbSunGearSpeed.setText(String.valueOf(nSunGearSpeed) + " rpm");
  }

  void sliRingGear_stateChanged(ChangeEvent e) {
    PlanetaryGear planetaryGear = m_thsController.getPlanetaryGear();
    planetaryGear.setRingGearSpeed((double)sliRingGear.getValue());
    sliSunGear.setValue((int)planetaryGear.getSunGearSpeed());

    viewGearsSpeed();
  }
  void sliPlaCarrier_stateChanged(ChangeEvent e) {
    PlanetaryGear planetaryGear = m_thsController.getPlanetaryGear();
    planetaryGear.setPlaCarrierSpeed((int)sliPlaCarrier.getValue() - sliPlaCarrier.getValue() % 50);
    sliSunGear.setValue((int)planetaryGear.getSunGearSpeed());

    viewGearsSpeed();
  }

  void sliPlaCarrier_mouseReleased(MouseEvent e) {
    sliPlaCarrier.setValue(sliPlaCarrier.getValue() - sliPlaCarrier.getValue() % 50);
    if (sliPlaCarrier.getValue() < 1000) {
      if (sliPlaCarrier.getValue() < 500)
        sliPlaCarrier.setValue(0);
      else
        sliPlaCarrier.setValue(1000);
    }
  }

  void sliPlaCarrier_keyReleased(KeyEvent e) {
    sliPlaCarrier_mouseReleased(null);
  }

  void ckDriveMode_actionPerformed(ActionEvent e) {
    sliRingGear.setValue(0);
    sliPlaCarrier.setValue(0);
    sliSunGear.setValue(0);

    m_thsController.getPlanetaryGear().setRingGearSpeed(0.0);
    m_thsController.getPlanetaryGear().setPlaCarrierSpeed(0.0);

    lbRingGearSpeed.setText("0 rpm");
    lbPlaCarrierSpeed.setText("0 rpm");
    lbSunGearSpeed.setText("0 rpm");
  }

  void sliAccel_mouseReleased(MouseEvent e) {
    sliAccel.setValue(0);
  }

  void sliBrake_mouseReleased(MouseEvent e) {
    sliBrake.setValue(0);
  }

  void sliAccel_keyReleased(KeyEvent e) {
    sliAccel.setValue(0);
  }

  void sliBrake_keyReleased(KeyEvent e) {
    sliBrake.setValue(0);
  }

  void sliAccel_stateChanged(ChangeEvent e) {
//    jLabel6.setText(String.valueOf(sliAccel.getValue()));
  }

  void sliBrake_stateChanged(ChangeEvent e) {
    //
  }

  void sliRingGear_mouseReleased(MouseEvent e) {
    sliRingGear.setValue(sliRingGear.getValue() - sliRingGear.getValue() % 50);
  }

  void sliRingGear_mouseMoved(MouseEvent e) {
    m_sMessage1 = "[^[̓OMA(/)ƂȂĂ܂B";
    m_sMessage2 = "OMẢ]̓^C̉]iN}̃Xs[hjƔႵ܂B";
  }

  void sliPlaCarrier_mouseMoved(MouseEvent e) {
    m_sMessage1 = "GW̓vl^LA(/)ƂȂĂ܂B";
    m_sMessage2 = "vl^LAɂ͂S̃sjIMA(/)܂B";
  }

  void sliSunGear_mouseMoved(MouseEvent e) {
    m_sMessage1 = "d@̓TMA(/)ƂȂĂ܂B";
    m_sMessage2 = "d@̓GW̃X^[^[ƂĂp܂B";
  }

  void jPanel1_mouseMoved(MouseEvent e) {
    m_sMessage1 = "XC_𓮂ƁA͕@\(V)̉]V~[gł܂B";
    m_sMessage2 = "";
  }

  void jPanel2_mouseMoved(MouseEvent e) {
    m_sMessage1 = "\"^]\"`FbNƃANZƃu[L̓V~[gł܂B";
    m_sMessage2 = "";
  }

  void cmbRange_itemStateChanged(ItemEvent e) {
    switch (cmbRange.getSelectedIndex()) {
    case 0:
      sliRingGear.setValue(0);
      sliPlaCarrier.setValue(0);
      m_thsController.setShiftPosition("P");
      break;
    case 1:
      sliRingGear.setValue(0);
      sliPlaCarrier.setValue(0);
      m_thsController.setShiftPosition("R");
      break;
    case 2:
      sliRingGear.setValue(0);
      sliPlaCarrier.setValue(0);
      m_thsController.setShiftPosition("N");
      break;
    case 3:
      if (! m_thsController.getShiftPosition().equals("D")) {
        if (! m_thsController.getShiftPosition().equals("B")) {
          sliRingGear.setValue(0);
          sliPlaCarrier.setValue(0);
        }
        m_thsController.setShiftPosition("D");
      }
      break;
    case 4:
      if (! m_thsController.getShiftPosition().equals("B")) {
        System.out.println(m_thsController.getShiftPosition());
        if (! m_thsController.getShiftPosition().equals("D")) {
          sliRingGear.setValue(0);
          sliPlaCarrier.setValue(0);
        }
        m_thsController.setShiftPosition("B");
      }
      break;
    }
  }

  void cmbRange_actionPerformed(ActionEvent e) {
//
  }
}